function createDomFromArr(array, typeName, btn = 'true') {
  let str = '<ul>'
  array.forEach(function (item, index) {
    if (btn) {
      if (typeName == 'baidu') {
        if (item.favo == 2) {
          str += `<li style='display:flex;justify-content:space-between;margin:6px;border-bottom:1px solid #e5e5e5;'><p><a href='https://www.baidu.com/s?wd=${item.words}' target='_blank'>${item.words}</a></p><button class='favo8' data-id='${item.id}'>收藏</button></li>`
        } else {
          str += `<li style='display:flex;justify-content:space-between;margin:6px;border-bottom:1px solid #e5e5e5;'><p><a href='https://www.baidu.com/s?wd=${item.words}' target='_blank'>${item.words}</a></p></li>`
        }
      } else {
        if (item.favo == 2) {
          str += `<li style='display:flex;justify-content:space-between;margin:6px;border-bottom:1px solid #e5e5e5;'><p><a href='https://www.google.com/search?q=${item.words}' target='_blank'>${item.words}</a></p><button class='favo8' data-id='${item.id}'>收藏</button></li>`
        } else {
          str += `<li style='display:flex;justify-content:space-between;margin:6px;border-bottom:1px solid #e5e5e5;'><p><a href='https://www.google.com/search?q=${item.words}' target='_blank'>${item.words}</a></p></li>`
        }
      }
    } else {
      if (item.type == 'baidu') {
        str += `<li style='display:flex;justify-content:space-between;margin:6px;border-bottom:1px solid #e5e5e5;'><p><a href='https://www.baidu.com/s?wd=${item.words}' target='_blank'>${item.words}</a></p></li>`
      } else {
        str += `<li style='display:flex;justify-content:space-between;margin:6px;border-bottom:1px solid #e5e5e5;'><p><a href='https://www.google.com/search?q=${item.words}' target='_blank'>${item.words}</a></p></li>`
      }
    }
  })
  str += '</ul>'
  return str
}

function getKeywords(res) {
  // console.log(res);
  $('#content_right').empty()
  $('#content_right').prepend(
    `<div id='kwc-panel' style='width:455px;margin-bottom:30px;'><div id='baidu'><h4 style='display:flex;justify-content:space-between;'><span>百度</span><span style='cursor:pointer;' class='closePanel'>X</span></h4></div><div id='google'><h4>谷歌</h4></div><div id='favorite'><h4>收藏</h4></div></div>`
  )
  if (res && res.hasOwnProperty('err_code')) {
    console.log(res)
  } else if (res) {
    let baiduArr = res.baidu
    let googleArr = res.google
    let favoriteArr = res.favorite
    let baiduDom = createDomFromArr(baiduArr, 'baidu')
    let googleDom = createDomFromArr(googleArr, 'google')
    let favoriteDom = createDomFromArr(favoriteArr, '', false)
    $('#baidu').append(baiduDom)
    $('#google').append(googleDom)
    $('#favorite').append(favoriteDom)
    // addEventToBtn();
  }
}

// // 处理收藏
// function toFavorite(fid) {
//   chrome.runtime.sendMessage({ fid }, function (response) {
//     console.log("收到来自后台的回复：" + response);
//   });
// }
// function closePanel() {
//   $("#kwc-panel").hide();
// }

// function addEventToBtn() {
//   // 收藏事件
//   $("body").on("click", ".favo8", function () {
//     const favo_id = $(this).data("id");
//     toFavorite(favo_id);
//   });
//   // 点击X关闭右侧栏
//   $("body").on("click", ".closePanel", function () {
//     closePanel();
//   });
// }

// chrome.runtime.onMessage.addListener(
//   // this is the message listener
//   function (request, sender, sendResponse) {
//     if (request.message === 'messageSent') runThisFunction()
//   }
// )

chrome.runtime.onMessage.addListener(function (msg, sender, sendResponse) {
  console.log(msg, '111111')
  if (msg.action == 'SendIt') {
    let res = msg.res
    if (res && res.err_code > 10000) {
      $('#kwcc').css('color', 'red')
      $('#kwcc').html(res.err_msg)
    } else if (res && res.err_code == 10000) {
      $('#kwcc').css('color', 'blue')
      $('#kwcc').html(res.msg)
    } else {
      $('#kwcc').html('服务器没有返回任何信息')
    }
    sendResponse('content我收到你的消息了')
    return true
  }
  if (msg.action == 'SendIt2') {
    let res = msg.res
    console.log(res)
    getKeywords(res)
    sendResponse('content我收到你的消息了222222')
    return true
  }
})

// 注意，必须设置了run_at=document_start 此段代码才会生效
document.addEventListener('DOMContentLoaded', function () {
  if (location.host == 'www.baidu.com') {
    function fuckBaiduAD() {
      if (document.getElementById('my_custom_css')) return
      var temp = document.createElement('style')
      temp.id = 'my_custom_css'
      ;(document.head || document.body).appendChild(temp)
      var css = `
			/* 移除百度右侧广告 */
			#content_right>table{display:none;}
			/* 覆盖整个屏幕的相关推荐 */
			.rrecom-btn-parent{display:none;}'
			/* 难看的按钮 */
			.result-op.xpath-log{display:none !important;}`
      temp.innerHTML = css
      console.log('已注入自定义CSS！')
      // 屏蔽百度推广信息
      removeAdByJs()
      // 这种必须用JS移除的广告一般会有延迟，干脆每隔一段时间清楚一次
      interval = setInterval(removeAdByJs, 2000)

      // 重新搜索时页面不会刷新，但是被注入的style会被移除，所以需要重新执行
      temp.addEventListener('DOMNodeRemoved', function (e) {
        console.log('自定义CSS被移除，重新注入！')
        if (interval) clearInterval(interval)
        // fuckBaiduAD();
        setTimeout(fuckBaiduAD, 1500)
      })
    }
    let interval = 0
    function removeAdByJs() {
      $('[data-tuiguang]').parents('[data-click]').remove()
    }
    fuckBaiduAD()
  }
})
