chrome.storage.sync.get(['token'], function(result) {
    $("#token").val(result.token);
});
$("#check-token").on('click', function(){
    let token = $("#token").val();
    if(token == ''){
        alert("请填写token");
        return;
    }
    chrome.storage.sync.set({token: token}, function() {
        console.log('Token is set to ');
    });
    // 向服务器发送http请求确认token是否有效
    $.ajax({
        method: "POST",
        url: "https://www.keywords.cool/api/v1/token/validity",
        data: { token: token },
        dataType: "json"
      })
    .done(function( res ) {
        if(res.err_code >10000){
            $(".result").removeClass('right');
            $(".result").text(res.err_msg);
            $(".result").addClass('error');
        } else {
            $(".result").removeClass('error');
            $(".result").text(res.err_msg);
            $(".result").addClass('right');  
        }
        setTimeout(function(){
            $(".result").text("");
        },3000);
    })
    .fail(function( jqXHR, textStatus ) {
        alert( "Request failed: " + textStatus );
    });
});